#undef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#include <Windows.h> // gettickcount
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "textfx.h"
#include "conio.h"
#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.h"

unsigned int fb[320*200];
unsigned int *img[5];

unsigned int byteswap(unsigned int i)
{
	return 
		((i & 0x00ff00) >>  0) |
		((i & 0x0000ff) << 16) |
		((i & 0xff0000) >> 16) ;
}


void img2fb_2x2(unsigned int *img)
{
	int i, j;
	for (i = 0; i < 100; i++)
		for (j = 0; j < 160; j++)
			fb[i * 160 + j] = byteswap(img[(i*2)*320+j*2]);
}

void img2fb_4x4(unsigned int *img)
{
	int i, j;
	for (i = 0; i < 200; i++)
		for (j = 0; j < 320; j++)
			fb[i * 320 + j] = byteswap(img[(i)*320+j]);
}


#ifdef TFX_SLOW_GENERATORS
void precalc()
{
/*
	{
		// Build color2x2 LUT and save to disk (this takes a while)
		alloc_lut_color2x2();
		extract_colors_2x2();
		build_lut_2x2();
		FILE * f = fopen("lut2x2.dat","wb");
		fwrite(lut_color2x2,64*64*64*64*2,1,f);
		fclose(f);
	}
	*/
	/*
	{
		// Build 4x4 LUT and save to disk (this takes a while)
		alloc_lut_hires();
		extract_colors_4x4();
		build_lut_4x4();
		f = fopen("lut4x4.dat","wb");
		fwrite(lut_hires,3*3*3*3* 3*3*3*3* 3*3*3*3* 3*3*3*3* 2,1,f);
		fclose(f);
	}
*/
}
#endif

void deinterleave(char *src, char *dst, int totalbytes)
{
	int i, j;
	for (i = 0, j = 0; i < totalbytes; i++, j+=2)
	{
		if (j >= totalbytes) j = 1;
		dst[i] = src[j];
	}
}

void demomain()
{
	TFX_printf(0,0,7,"Loading..");	TFX_Present();
	TFX_printf(0,1,7,"images");	TFX_Present();

	int x, y, comp;
	img[0] = (unsigned int*)stbi_load("testimg/rose.png",&x,&y,&comp,4);
	img[1] = (unsigned int*)stbi_load("testimg/lena_crop.bmp",&x,&y,&comp,4);
	img[2] = (unsigned int*)stbi_load("testimg/colramp.bmp",&x,&y,&comp,4);
	img[3] = (unsigned int*)stbi_load("testimg/satramp.bmp",&x,&y,&comp,4);
	img[4] = (unsigned int*)stbi_load("testimg/curves.bmp",&x,&y,&comp,4);


	// precalc();

	TFX_printf(0,2,7,"lut_hires");	TFX_Present();
//	load_lut_hires("lut_hires.dat");
	load_lut_hires_png("lut_hires-zopfli.png");
	TFX_printf(0,3,7,"lut_color2x2");	TFX_Present();
//	load_lut_color2x2("resolation.dat");
	load_lut_color2x2_png("resolation-zopfli.png");

	TFX_printf(0,4,7,"precalc");	TFX_Present();
	build_lut_blockcolor();   // \ 
	//build_lut_longramp();   //  > these are pretty fast these days..
	build_lut_asciiart();     // /

	int loop = 0;
	unsigned int starttick = GetTickCount();
	while (1)
	{
		unsigned int tick = GetTickCount() - starttick;
		
		while (_kbhit())
		{
			loop++;
			int c = _getch();
			if (c != 32) exit(0);
		}

		unsigned int frame = (tick / (2500*6)) % 5;
		unsigned int mode = (tick / 2500) % 6;

		if (mode < 5)
		{
			img2fb_2x2(img[frame]);
		}
		else
		{
			img2fb_4x4(img[frame]);
		}

		switch (mode)
		{
		case 0:	convert_color2x2_160x100(fb); break;
		case 1:	convert_halfblockcolor_160x100(fb); break;
		case 2:	convert_blockcolor_160x100(fb); break;
		case 3:	convert_asciiart_160x100(fb); break;
		case 4: convert_blockmixer_160x100(fb); break;
		case 5: convert_hires_320x200(fb); break;
		}

		char *imagename[5] = { "rose", "lena", "colramp", "satramp", "curves" };
		char *filtername[6] = { "color2x2", "halfblockcolor", "blockcolor", "asciiart", "blockmixer", "hires"};

		TFX_printf(0,0,0x1f,"  Image :%14s  ", imagename[frame]);
		TFX_printf(0,1,0x1f,"  Filter:%14s  ", filtername[mode]);


		TFX_Present();
	}
}