///////////////////////////////////////////////
// Copyright
///////////////////////////////////////////////
//
// TextFX8
// Copyright (c) 1995-2018 Jari Komppa
//
//
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
// 
//
///////////////////////////////////////////////

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "textfx.h"

int diff(int a, int b)
{
	return
		abs(((a >> 0) & 0xff) - ((b >> 0) & 0xff)) +
		abs(((a >> 8) & 0xff) - ((b >> 8) & 0xff)) +
		abs(((a >> 16) & 0xff) - ((b >> 16) & 0xff));
}

void detect_edges(unsigned int *aSource, unsigned char *aMask)
{
	unsigned int buf[160 * 100];
	int i, j, c;
	for (i = 0, c = 0; i < 100; i++)
	{
		for (j = 0; j < 160; j++, c++)
		{
			int x0 = j - 1;
			int y0 = i - 1;
			int x1 = j + 1;
			int y1 = i + 1;
			if (x0 < 0) x0 = 0;
			if (y0 < 0) y0 = 0;
			if (x1 > 159) x1 = 159;
			if (y1 > 99) y1 = 99;
			buf[c] = diff(aSource[y0 * 160 + x0], aSource[y1 * 160 + x1]);
		}
	}

	for (i = 0, c = 0; i < 50; i++)
	{
		for (j = 0; j < 80; j++, c++)
		{
			aMask[c] =
				(buf[i * 2 * 160 + j * 2 + 0] +
				buf[i * 2 * 160 + j * 2 + 1] +
				buf[i * 2 * 160 + j * 2 + 160] +
				buf[i * 2 * 160 + j * 2 + 161]) < 3*32;
		}
	}
}

void convert_blockmixer_160x100(unsigned int *aSource, unsigned short *aTarget)
{
	unsigned short t1[80 * 50];
	unsigned short t2[80 * 50];
	unsigned char mask[80 * 50];
	detect_edges(aSource, mask);
	convert_blockcolor_160x100(aSource, t1);
	convert_halfblockcolor_160x100(aSource, t2);
	int i;
	for (i = 0; i < 80 * 50; i++)
		if (mask[i])
			aTarget[i] = t1[i];
		else
			aTarget[i] = t2[i];
}

